#!/usr/bin/perl -w

use strict;
use Getopt::Long;
use Pod::Usage;

my $man = 0;
my $help = 0;
my ($inDir, $tree,$outfile,$treefile) = ('','GLtreeTemplate','','');

### ------------------------------------------------------------------------- ###
# manpage, help, usage..

GetOptions(
           "help|?" => \$help,
           "man"    => \$man,
           "d:s"    => \$inDir,
	   "o:s"    => \$outfile
          ) or pod2usage(1);

pod2usage(1) if $help;

pod2usage(-verbose => 2) if $man;

#if($tree eq '') {
#  pod2usage(1);
#}

if(! (-d $inDir)) {
  printf STDERR "\nERROR: Cannot acces input directory '%s'\n", $inDir;
  pod2usage(1);
}

### ------------------------------------------------------------------------- ###
# read and hash all trees

# read tree template
#my %tree;
#my $n = 0;
#open(T, $tree) or die $!;
#while(<T>) {
#  chomp();
#  my @x = split;
#
#  $x[1] =~ s/"//g;
#  $tree{$x[0]}{name} = $x[1];
#  $tree{$x[0]}{p} = $x[2];
#  my @z = split /\,/,
#  $tree{$x[0]}{l} = $x[3];
#  $tree{$x[0]}{r} = $x[4];
#  $tree{$x[0]}{level} = $x[5];
#  $tree{$x[0]}{m} = 0;
#  $tree{$x[0]}{gain} = 0;
#  $tree{$x[0]}{loss} = 0;
#  $tree{$x[0]}{inno} = 0;
#
#  $n++;
#}
#close(T);

# read directory of data
opendir(D, $inDir) or die $!;
my @entries = grep {/\.ePoPE\.out$/} readdir(D);
closedir(D);

# fill tree hash wit data
my %tree;
my ($i,$nodes_n) = (0,0);
foreach my $e (@entries) {
  my $file = $inDir."/".$e;
  printf "%s\n",$file; 
  open(E, $file) or die $!;

  while(<E>) {
    chomp();
    my $line = $_;
 #   print $line;
    my @x = split /\s+/,$line;
#    next;

#pos:  16 lab: 329 kids: -1 pInP:  16 par: 327 mirs:   0 gain:   0 loss   0       seenBW:   1 gainFam:   0        lossFam:   0    egr

    $i = $x[7]; #/* use i as identifier and preorder position of tree */

    # write first instance in tree
    if(! exists($tree{$i})) {
	$tree{$i}{name} = $x[scalar @x -1]; chomp($tree{$i}{name});
	$tree{$i}{pos} = $x[1];
	$tree{$i}{lab} = $x[3];
	$tree{$i}{p} = $x[9];
	$tree{$i}{c} = $x[5];
	$tree{$i}{m} = $x[11];
	$tree{$i}{gain} = $x[13];
	$tree{$i}{loss} = $x[15];
	$tree{$i}{gainF} = $x[19];
	$tree{$i}{lossF} = $x[21];
	$nodes_n++;
    } else { # add values to existing tree
	$tree{$i}{m} += $x[11];
	$tree{$i}{gain} += $x[13];
	$tree{$i}{loss} += $x[15];
	$tree{$i}{gainF} += $x[19];
	$tree{$i}{lossF} += $x[21];

    }
  }
  close(E);

}

open(O, ">", $outfile) or die $!;
for($i=0; $i<$nodes_n; $i++) {
    printf O "pos: %d lab: %d kids: %s pInP: %d par: %d ",$tree{$i}{pos},$tree{$i}{lab},$tree{$i}{c},$i,$tree{$i}{p};
    printf O "mirs: %d gain: %d loss: %d ",$tree{$i}{m},$tree{$i}{gain},$tree{$i}{loss};
    printf O "seenBW: 1 gainFam: %d lossFam: %d %s\n",$tree{$i}{gainF},$tree{$i}{lossF},$tree{$i}{name};
}
close(O);

#  # get lca of subtree -> add 'innovation' entry to tree
#  my ($labFirst, $labLast) = (-1, -1);
#  my ($i,@A);
#
#  $i = 0;
#  while(1) {
#      push @A, $i;
#      if($subtree{$i}{l} == -1) {
#	  if($subtree{$i}{r} == -1) { # leaf
#	      if($subtree{$i}{m} > 0) {
#		  if($labFirst == -1) { $labFirst = $i; }
#		  else { $labLast = $i; }
#	      }
#	      $i = $subtree{$i}{p};
#	  }
#      } else {
#	  if($subtree{$subtree{$i}{l}}{v} == -1) {
#	      $i = $subtree{$i}{l};
#	      $subtree{$i}{v} = 1;
#	  } elsif($subtree{$subtree{$i}{r}}{v} == -1) {
#	      $i = $subtree{$i}{r};
#	      $subtree{$i}{v} = 1;
#	  } else {
#	      if($subtree{$i}{p} == -1) { last; }
#	    $i = $subtree{$i}{p};
#	  }
#    }
#  }
#
#  # get LCA
#  $i = $labFirst;
#  my $j = $labLast;
#  while($i != $j) {
#      if($subtree{$i}{level} == $subtree{$j}{level}) {
#	  $i = $subtree{$i}{p};
#	  $j = $subtree{$j}{p};
#      } elsif($subtree{$i}{level} > $subtree{$j}{level}) {
#	  $i = $subtree{$i}{p};
#      } else {
#	  $j = $subtree{$j}{p};
#      }
#  }
#
#  my $lca = $i;
#  $tree{$lca}{inno}++;
#  #printf "lca: %d\n",$lca;
#  
#  close(E);
#}

# print final tree to outfile
#open(O, ">", $outfile) or die $!;
#for(my $i=0; $i<$n; $i++) {
#  printf O "%-20s n: %-3d p: %-3d ",$tree{$i}{name},$i,$tree{$i}{p};
#  printf O "l: %-3d r: %-3d ",$tree{$i}{l}, $tree{$i}{r};
#  printf O "level: %-3d score: %-3d ",$tree{$i}{level},$tree{$i}{m};
#  printf O "gain: %-3d loss: %-3d ",$tree{$i}{gain},$tree{$i}{loss};
#  printf O "inno: %-3d\n",$tree{$i}{inno};
#}
#close(O);

# ./GLparaSummarize.pl -d testout/ -o summary.dat
# sort -k 5,3 -n  summary.dat | awk '{printf "%-20s %4d %4d %4d\n",$1,$13,$15,$17;}' > summary.sorted.dat


### ------------------------------------------------------------------------- ###

__END__

=head1 NAME

GLparaSummarize.pl - summarizes the data output files of GLparaPred.

=head1 SYNOPSIS

GLparaSummarize.pl [-d DIR -o FILE]

=head1 OPTIONS

=over 8

=item B<-help>

Print a brief help message and exits.

=item B<-man>

Prints the manual page and exits.

=item B<-d DIR>

the directory that contains the data output files of
GLparaPred. The ending of the files is '.dat'.

=item B<-o FILE>

the output file for the final summarized tree data.

=back

=head1 DESCRIPTION

B<GLparaSummarize.pl.pl> summarizes the data output files of
GLparaPred, returns the summarized tree in space seperated table
format which can easily be read by the GLparaVisualize tool that
creates a PostScript tree, or with other tools that analyse the data
(e.g. R).

=cut
